/*
Copyright The Clusternet Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/clusternet/clusternet/pkg/apis/apps/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeFeedInventories implements FeedInventoryInterface
type FakeFeedInventories struct {
	Fake *FakeAppsV1alpha1
	ns   string
}

var feedinventoriesResource = schema.GroupVersionResource{Group: "apps.clusternet.io", Version: "v1alpha1", Resource: "feedinventories"}

var feedinventoriesKind = schema.GroupVersionKind{Group: "apps.clusternet.io", Version: "v1alpha1", Kind: "FeedInventory"}

// Get takes name of the feedInventory, and returns the corresponding feedInventory object, and an error if there is any.
func (c *FakeFeedInventories) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.FeedInventory, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(feedinventoriesResource, c.ns, name), &v1alpha1.FeedInventory{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FeedInventory), err
}

// List takes label and field selectors, and returns the list of FeedInventories that match those selectors.
func (c *FakeFeedInventories) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.FeedInventoryList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(feedinventoriesResource, feedinventoriesKind, c.ns, opts), &v1alpha1.FeedInventoryList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.FeedInventoryList{ListMeta: obj.(*v1alpha1.FeedInventoryList).ListMeta}
	for _, item := range obj.(*v1alpha1.FeedInventoryList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested feedInventories.
func (c *FakeFeedInventories) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(feedinventoriesResource, c.ns, opts))

}

// Create takes the representation of a feedInventory and creates it.  Returns the server's representation of the feedInventory, and an error, if there is any.
func (c *FakeFeedInventories) Create(ctx context.Context, feedInventory *v1alpha1.FeedInventory, opts v1.CreateOptions) (result *v1alpha1.FeedInventory, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(feedinventoriesResource, c.ns, feedInventory), &v1alpha1.FeedInventory{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FeedInventory), err
}

// Update takes the representation of a feedInventory and updates it. Returns the server's representation of the feedInventory, and an error, if there is any.
func (c *FakeFeedInventories) Update(ctx context.Context, feedInventory *v1alpha1.FeedInventory, opts v1.UpdateOptions) (result *v1alpha1.FeedInventory, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(feedinventoriesResource, c.ns, feedInventory), &v1alpha1.FeedInventory{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FeedInventory), err
}

// Delete takes name of the feedInventory and deletes it. Returns an error if one occurs.
func (c *FakeFeedInventories) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(feedinventoriesResource, c.ns, name, opts), &v1alpha1.FeedInventory{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeFeedInventories) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(feedinventoriesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.FeedInventoryList{})
	return err
}

// Patch applies the patch and returns the patched feedInventory.
func (c *FakeFeedInventories) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.FeedInventory, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(feedinventoriesResource, c.ns, name, pt, data, subresources...), &v1alpha1.FeedInventory{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.FeedInventory), err
}
